const { set } = require('lodash')
const { services } = require('pubsweet-component-helper-service')

module.exports = models => async (req, res) => {
  const { subscribe, id } = req.body

  if (!services.checkForUndefinedParams(subscribe, id))
    return res.status(400).json({ error: 'Missing required params.' })

  let user
  try {
    user = await models.User.find(id)
    set(user, 'notifications.email.user', subscribe)
    user = await user.save()

    return res.status(200).json({ user })
  } catch (e) {
    const notFoundError = await services.handleNotFoundError(e, 'User')
    return res.status(notFoundError.status).json({
      error: notFoundError.message,
    })
  }
}
